/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.Fighter
 *  fire.pb.battle.Monster
 *  fire.pb.battle.ResultItem
 *  fire.pb.battle.SCatchRate
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.MonsterConfig
 *  fire.pb.pet.Module
 *  fire.pb.pet.PAddPetByPetID
 *  fire.pb.pet.PetAttr
 *  fire.pb.pet.PetColumn
 *  fire.pb.talk.MessageMgr
 *  xbean.BattleInfo
 *  xbean.Fighter
 *  xbean.Monster
 *  xbean.MonsterSkill
 */
package fire.pb.option;

import fire.pb.battle.BattleField;
import fire.pb.battle.Monster;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SCatchRate;
import fire.pb.main.ConfigManager;
import fire.pb.npc.MonsterConfig;
import fire.pb.option.BasicOperation;
import fire.pb.pet.Module;
import fire.pb.pet.PAddPetByPetID;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.talk.MessageMgr;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Map;
import xbean.BattleInfo;
import xbean.Fighter;
import xbean.MonsterSkill;

public class CatchPet
extends BasicOperation {
    private int seizeResult = 0;
    protected int mpconsume = 0;

    public CatchPet(BattleInfo battle, int operator, int aim) {
        super(battle, operator, aim);
    }

    @Override
    public int getType() {
        return this.isFailed ? 20 : 8;
    }

    @Override
    public int getOperateID() {
        return this.isFailed ? this.failreason : 0;
    }

    @Override
    public int getResultType() {
        return this.seizeResult;
    }

    @Override
    public void process() {
        int starId;
        boolean success;
        float frate;
        long roleID = BattleField.getRoleIDByIndex((BattleInfo)this.getBattle(), (int)this.getOperator());
        if (0L == roleID) {
            return;
        }
        fire.pb.battle.Fighter aimfighter = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(this.getAim());
        if (null == aimfighter) {
            this.isFailed = true;
            this.failreason = 142937;
            return;
        }
        if (aimfighter.getFightertype() < 3) {
            this.isFailed = true;
            this.failreason = 142937;
            return;
        }
        int monsterBaseID = (int)aimfighter.getFighterBean().getUniqueid();
        MonsterConfig cfg = Monster.getMonsterConfig((int)monsterBaseID);
        if (cfg == null || cfg.canCatch == 0) {
            this.isFailed = true;
            this.failreason = 142937;
            return;
        }
        int petID = cfg.getPet();
        boolean isbind = cfg.orbinding == 1;
        float catchRate = (float)cfg.catchRate / 1000.0f;
        if (0 == petID) {
            this.isFailed = true;
            this.failreason = 142937;
            return;
        }
        int takelevel = Module.getInstance().getPetTakeLevel(petID);
        if (takelevel > this.opfighter.getEffectRole().getLevel()) {
            this.isFailed = true;
            this.failreason = 141685;
            MessageMgr.psendMsgNotify((long)roleID, (int)150079, Arrays.asList(cfg.getName(), takelevel + ""));
            return;
        }
        PetColumn petcol = new PetColumn(this.opfighter.getFighterBean().getUniqueid(), 1, false);
        if (petcol.size() >= petcol.getCapacity()) {
            this.isFailed = true;
            this.failreason = 160198;
            MessageMgr.sendMsgNotify((long)roleID, (int)160198, null);
            return;
        }
        SCatchRate scatchrate = null;
        float curperc = aimfighter.getEffectRole().getHpPercent() * 100.0f;
        for (SCatchRate rate : CatchPet.getSCatchRate().values()) {
            if (!(curperc > (float)rate.getLowerlimit()) || !(curperc <= (float)rate.getUpperlimit())) continue;
            scatchrate = rate;
            break;
        }
        if (scatchrate != null) {
            catchRate = (float)((double)catchRate * scatchrate.getCatchfactor() + scatchrate.getCatchconst());
        }
        if (this.opfighter.getSkillAgent().hasEffectSkill(430033)) {
            catchRate = (float)((double)catchRate + 0.2);
        }
        if ((frate = (float)Math.random()) > catchRate) {
            return;
        }
        xbean.Monster xmonster = (xbean.Monster)this.getBattle().getMonsters().get(this.getAim());
        ArrayList<Integer> skillids = new ArrayList<Integer>();
        for (MonsterSkill mskill : xmonster.getSkills()) {
            skillids.add(mskill.getId());
        }
        int lv = 0;
        PetAttr petAttr = Module.getInstance().getPetManager().getAttr(petID);
        if (petAttr != null) {
            lv = petAttr.getInitlevel();
        }
        int type = 2;
        if (petAttr != null) {
            type = petAttr.getKind();
        }
        if (!(success = new PAddPetByPetID(roleID, petID, lv, 1, type, skillids, 1, starId = 1, isbind).call())) {
            this.isFailed = true;
            return;
        }
        this.seizeResult = 2048;
        int aimresult = (Integer)this.getBattle().getRoundresult().get(this.getAim());
        this.getBattle().getRoundresult().put(this.getAim(), aimresult |= 0x800);
    }

    @Override
    public ResultItem getResultItem() {
        if (this.resultItem != null && this.isFailed) {
            this.resultItem.execute.msgid = this.failreason;
        }
        return super.getResultItem();
    }

    int getMonserBaseID() {
        Fighter f = (Fighter)this.getBattle().getFighters().get(this.getAim());
        if (null == f) {
            return 0;
        }
        if (f.getFightertype() < 3) {
            return 0;
        }
        return (int)f.getUniqueid();
    }

    public String toString() {
        return this.getOperator() + "\t捕捉\t" + this.getAim();
    }

    @Override
    public int getMPconsume() {
        return this.mpconsume;
    }

    private static Map<Integer, SCatchRate> getSCatchRate() {
        return ConfigManager.getInstance().getConf(SCatchRate.class);
    }

    @Override
    public boolean canChangeAim() {
        return true;
    }
}

